<?php

$block_name = _("Wishlist Summary");

/**
 * $Horde: genie/lib/Block/summary.php,v 1.11 2004/10/19 15:21:50 mdjukic Exp $
 *
 * @package Horde_Block
 */
class Horde_Block_Genie_summary extends Horde_Block {

    var $_app = 'genie';

    function _title() 
    {
        global $registry;
        $html  = Horde::link(Horde::applicationUrl($registry->getInitialPage(), true), $registry->get('name'), 'header') . $registry->get('name') . '</a> :: ';
        $html .= Horde::link(Horde::applicationUrl('item.php?actionID=' . GENIE_ADD_ITEM, true), _("New Item"), 'smallheader') . Horde::img('add.png', _("New Item"), 'hspace="5"', Horde::url($registry->getImageDir(), true, -1)) . _("New Item") . '</a>';

        return $html;
    }
    
    function _content() 
    {
        global $registry, $prefs;
        require_once dirname(__FILE__) . '/../base.php';

        $html = '';
        foreach (_genie_list() as $id => $item) {
            $due_begin = $due_end = '';
            $closed_begin = $closed_end = '';
            $owner = '';

            $html .= '<tr><td class="text">';
            $viewurl = Util::addParameter('view.php', 'item=' . $item['item_id']);
            $viewurl = Util::addParameter($viewurl, 'wishlist=' . $item['wishlist_id']);
            $row = Horde::link(Horde::applicationUrl($viewurl, true), $item['name']);

            if ($prefs->getValue('summary_show_owner')) {
                $owner = $item['wishlist_id'];
                $shares = &Horde_Share::singleton($registry->getApp());
                $share = $shares->getShare($owner);
                if (is_a($share, 'PEAR_Error') || $owner == $share->get('owner')) {
                    $owner .= ' - ';
                } else {
                    $owner = $share->get('name') . ' - ';
                }
            }

            $row .= (!empty($item['name']) ? htmlspecialchars($item['name']) : _("[none]")) . '</a>';

            if (!empty($item['purchased'])) {
                $closed_begin = '<strike>';
                $closed_end = '</strike>';
            }
            $html .= $closed_begin . $owner . $row . $closed_end;
            $html .= "</td></tr>\n";
        }
    
        if (empty($html)) {
            $html = sprintf('<tr><td><i>%s</i></td></tr>', _("No items to display"));
        }    
        $html = '<table border="0" cellpadding="0" cellspacing="0" width="100%">' . $html . '</table>';

        return $html;
    }

}
