#!/usr/local/bin/php
<?php
/**
 * $Horde: genie/scripts/upgrades/2003-10-22_create_db_sequence.php,v 1.2 2005/01/03 14:34:50 jan Exp $
 *
 * Copyright 1999-2005 Charles J. Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

@define('AUTH_HANDLER', true);
@define('HORDE_BASE', dirname(__FILE__) . '/../..');
@define('GENIE_BASE', dirname(__FILE__) . '/..');

// Do CLI checks and environment setup first.
require_once HORDE_BASE . '/lib/core.php';
require_once 'Horde/CLI.php';

// Make sure no one runs this from the web.
if (!Horde_CLI::runningFromCLI()) {
    exit("Must be run from the command line\n");
}

// Load the CLI environment - make sure there's no time limit, init
// some variables, etc.
Horde_CLI::init();

require_once GENIE_BASE . '/lib/base.php';

$table = (isset($conf['storage']['params']['table']) ?
          $conf['storage']['params']['table'] :
          'genie_wishes');

$storage = &Genie_Driver::singleton('');
$storage->_connect();
$db = &$storage->_db;

// Get the current max id.
$max = $db->getOne('SELECT MAX(wish_id) FROM ' . $table);

// Make sure the sequence is at least that high.
while ($db->nextId($table) <= $max);

echo "** Sequence table successfully updated ***\n";
