#!/usr/local/bin/php
<?php
/**
 * $Horde: genie/scripts/upgrades/2004-05-19_convert_categories_to_strings.php,v 1.2 2005/01/03 14:34:50 jan Exp $
 *
 * Copyright 2004-2005 Charles J. Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/licenses/bsdl.php.
 */

@define('AUTH_HANDLER', true);
@define('GENIE_BASE', dirname(__FILE__) . '/../..');
require_once GENIE_BASE . '/lib/base.php';

// Run through every wishlist.
$wishlists = $genie_shares->listAllShares();
foreach ($wishlists as $wishlist => $share) {
    echo "Converting categories for $wishlist ...\n";

    $categories = listCategories($wishlist);

    // List all tasks.
    $storage = &Genie_Driver::singleton($wishlist);
    $storage->retrieve();
    $items = $storage->listItems();

    foreach ($items as $itemId => $item) {
        if (isset($categories[$item['category']])) {
            $result = $storage->modify($itemId, $item['name'], $item['desc'], $item['quantity'], $item['price'],
                                       $item['prodid'], $item['prodid_type'], $item['vendors'],
                                       $categories[$item['category']], $item['purchased']);
            if (is_a($result, 'PEAR_Error')) {
                Horde::fatal($result);
            }
        }
    }
}

echo "\n** Categories successfully converted ***\n";
exit;

function listCategories($wishlist = null)
{
    global $prefs;

    static $catString, $categories;

    $cur = getPrefByShare('wish_categories', $wishlist);
    if (is_null($catString) || $catString != $cur) {
        $categories = array(0 => _("Unfiled"));

        $catString = $cur;
        if (empty($catString)) {
            return $categories;
        }

        $cats = explode('|', $catString);
        foreach ($cats as $cat) {
            list($key, $val) = explode(':', $cat);
            $categories[$key] = $val;
        }
    }

    asort($categories);
    return $categories;
}

function getPrefByShare($pref, $share = null)
{
    if (!is_a($share, 'DataTreeObject_Share')) {
        $share = $GLOBALS['genie_shares']->getShare($share);
        if (is_a($share, 'PEAR_Error')) {
            return null;
        }
    }

    $owner = $share->get('owner');
    $userprefs = &Prefs::singleton($GLOBALS['conf']['prefs']['driver'],
                                   $GLOBALS['registry']->getApp(),
                                   $owner, '', null, false);
    $userprefs->retrieve();
    return $userprefs->getValue($pref);
}
